//Ethan Alexander Shulman 2019

self.onmessage = function(msg) {
	//initialize options
	var size = msg.data[0], dim = msg.data[1], seed = msg.data[2], pts = new Float32Array(size*dim), szsq = Math.floor(Math.pow(size,1.0/dim)), ssz = size/szsq, szsq2 = Math.floor(szsq*0.5), gp = new Uint32Array(dim), jp = new Float32Array(dim), sp = new Float32Array(dim);
	
	function RNG() {
		var rv = seed%1.0;
		seed = (seed+rv*Math.PI+Math.PI)%(Math.PI*100.0);
		return rv;
	}
	
	//generate first point randomly
	for (var i = 0; i < dim; i++) pts[i] = RNG()*0.999*szsq;
	
	//loop through generating sample points
	for (var i = 1; i < size; i++) {
		//search jittered grid for point farthest away from all other points
		gp.fill(0);
		var maxd = -1e20;
		while (true) {
			for (var d = 0; d < dim; d++) jp[d] = gp[d]+RNG();
			
			var md = 1e20, pi = 0;
			for (var j = 0; j < i; j++) {
				var dst = 0.0;
				for (var d = 0; d < dim; d++) {
					var df = jp[d]-pts[pi++], ad = Math.abs(df);
					if (ad > szsq2) df = szsq-ad;
					dst += df*df;
				}
				md = Math.min(md,dst);
			}
			if (md > maxd) {
				sp.set(jp);
				maxd = md;
			}
			
			var d;
			for (d = 0; d < dim; d++) {
				var gv = gp[d]+1;
				if (gv < szsq) {
					gp[d] = gv;
					break;
				} else gp[d] = 0;
			}
			if (d >= dim) break;
		}
		
		if (maxd < 0.5) {
			i--;
			continue;
		}
		var pti = i*dim;
		for (var d = 0; d < dim; d++) pts[pti++] = sp[d];
	}
	
	//convert from grid units to normalized 0-1
	for (var i = 0; i < pts.length; i++) pts[i] /= szsq;
	
	//output sample points
	self.postMessage(pts);
};
